require 'regiment/service/version'
require 'pathname'

module Regiment
  class API
     
    ORDER_PATH = "/etc/regiment/orders/"

    def initialize
    end

    def version
      return Regiment::Service::VERSION
    end

    def execute(order, options={})
      path = Pathname.new(ORDER_PATH).join(Pathname.new("#{order}/#{order}.rb")).to_s
      
      # Classes have caps yo!
      order[0] = order[0].capitalize

      # Load our order, instantiate it and call do_execute
      Kernel.load(path)
      o = Object.const_get(order.to_sym).new

      return o.do_execute
    end

    def about(order, options={})
      begin
        info = File.new(Pathname.new(ORDER_PATH).join(Pathname.new("#{order}/README")).to_s)
      rescue IOError => e
        return e
      end
      return info
    end

  end
end
