require 'regiment/service/version'
require 'rest-client'
require 'uri'
 
module Regiment
  class Client 
    def initialize(endpoint)
      combined = endpoint.split(":")
      @host = combined[0]
      @port = combined[1].to_i
    end

    def build_uri(path)
      return URI::HTTP.build({:host => @host, :port => @port, :path => path}).to_s
    end
    
    def version
      return RestClient.get(build_uri("/version"))
    end
   
    def execute(order, options={})
      return RestClient.get(build_uri("/execute/#{order}"))
    end

    def about(order, options={})
      return RestClient.get(build_uri("/about/#{order}"))
    end

  end
end
