# Regiment::Order
# The super-class of all orders.

module Regiment
  class Order
    # Keep track of state
    @state = :initializing 
    
    def initialize(options={})
    end

    # do_thing methods wrap methods to be overriden in order imlpementation
    def do_execute(options={})
      @state = :executing
      results = execute
      return do_report(results)
    end

    def execute(options={})
    end

    def do_report(result, options={})
      @state = :reporting
      @report = result
      return report(result)
    end

    def report(result ,options={})
      return result
    end
  end
end
